
const {ccclass, property} = cc._decorator;

@ccclass
export default class Rotator extends cc.Component {

    @property(cc.Node)
    public box3d: cc.Node = null;

    @property(cc.Camera)
    public camera: cc.Camera = null;

    private _direction: cc.Vec3 = cc.v3();

    public onLoad(): void {
        this.node.on(cc.Node.EventType.MOUSE_MOVE, this._mouseUp, this);
    }

    public start(): void {

    }

    update (dt) {
        this._rotateToTarget();
    }

    private _mouseUp(e: cc.Event.EventMouse): void {
        const mouse = e.getLocation();
        const mouseLocation = cc.v3(mouse.x, mouse.y);
        const box3dLocation = this.node.convertToWorldSpaceAR(this.box3d.position);

        console.log(`ML: ${mouseLocation.x},${mouseLocation.y} BL: ${box3dLocation.x},${box3dLocation.y}`);

        this._direction = mouseLocation.subtract(box3dLocation);
    }

    private _rotateToTarget() {
        const radianAngle = Math.atan2(this._direction.y, this._direction.x);
        this.box3d.angle = cc.misc.radiansToDegrees(radianAngle);
    }
}
